## soapyvolkconverters 0.1.1

=== CMakeLists.txt ===
########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 3.1.0)
project(SoapyVOLKConverters CXX)
enable_testing()

#select the release build type by default to get optimization flags
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
   message(STATUS "Build type not specified: defaulting to release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")

# C++-14 required for VOLK
set(CMAKE_CXX_STANDARD 14)

########################################################################
# Dependencies
########################################################################
find_package(SoapySDR "0.7" REQUIRED)
find_package(Volk REQUIRED)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${SoapySDR_INCLUDE_DIRS}
    ${Volk_INCLUDE_DIRS})

########################################################################
# Build a Soapy module to add VOLK converters
########################################################################
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/config.in.h
    ${CMAKE_CURRENT_BINARY_DIR}/config.h)

SOAPY_SDR_MODULE_UTIL(
    TARGET volkConverters
    SOURCES SoapyVOLKConverters.cpp
    LIBRARIES
        Volk::volk
)

if(MSVC)
    target_compile_options(volkConverters PUBLIC /wd4251) #disable 'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
endif()

########################################################################
# Common code for unit test and benchmark
########################################################################
add_library(TestUtility STATIC TestUtility.cpp)
target_link_libraries(TestUtility Volk::volk)
if(MSVC)
    target_compile_options(TestUtility PUBLIC /wd4251) #disable 'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
endif()

########################################################################
# Add test
########################################################################
add_executable(TestSoapyVOLKConverters TestSoapyVOLKConverters.cpp)
add_test(TestSoapyVOLKConverters TestSoapyVOLKConverters)

# Link against Soapy, not the module, which is loaded at runtime
target_link_libraries(TestSoapyVOLKConverters
    TestUtility
    ${SoapySDR_LIBRARIES}
    Volk::volk)
if(MSVC)
    target_compile_options(TestSoapyVOLKConverters PUBLIC /wd4251) #disable 'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
endif()

########################################################################
# Benchmark VOLK vs. generic converters
########################################################################
add_executable(BenchmarkSoapyVOLKConverters BenchmarkSoapyVOLKConverters.cpp)

# Link against Soapy, not the module, which is loaded at runtime
target_link_libraries(BenchmarkSoapyVOLKConverters
    TestUtility
    ${SoapySDR_LIBRARIES}
    Volk::volk)
if(MSVC)
    target_compile_options(BenchmarkSoapyVOLKConverters PUBLIC /wd4251) #disable 'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
endif()

########################################################################
# Print Summary
########################################################################
MESSAGE(STATUS "Using install prefix: ${CMAKE_INSTALL_PREFIX}")

=== debian/changelog ===
soapyvolkconverters (0.1.1-1) unstable; urgency=medium

  * Initial release (Closes: #1109227)

 -- Andreas Bombe <aeb@debian.org>  Mon, 14 Jul 2025 14:47:31 +0200

=== debian/control ===
Source: soapyvolkconverters
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Andreas Bombe <aeb@debian.org>
Build-Depends:
    debhelper-compat (= 13),
    cmake,
    libvolk-dev,
    libsoapysdr0.8-dev
Standards-Version: 4.7.2
Homepage: https://github.com/pothosware/SoapyVOLKConverters/wiki
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/soapysdr/soapyvolkconverters
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/soapysdr/soapyvolkconverters.git
Rules-Requires-Root: no

Package: soapysdr0.8-module-volkconverters
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: soapysdr0.8-module
Description: Faster and more efficient numeric conversion functions for SoapySDR
 This SoapySDR module adds vectorized numeric conversion functions based
 on GNU Radio VOLK, providing more efficient conversions in many cases
 than with stock SoapySDR. Once this module is installed, nothing more
 needs to be done. Soapy modules that use SoapySDR's converter
 infrastructure will automatically default to these new converters.

Package: soapysdr-module-volkconverters
Architecture: any
Multi-Arch: same
Depends: soapysdr0.8-module-volkconverters, ${misc:Depends}
Description: Faster and more efficient numeric conversion functions for SoapySDR
 This SoapySDR module adds vectorized numeric conversion functions based
 on GNU Radio VOLK, providing more efficient conversions in many cases
 than with stock SoapySDR. Once this module is installed, nothing more
 needs to be done. Soapy modules that use SoapySDR's converter
 infrastructure will automatically default to these new converters.
 .
 This is an empty dependency package that pulls in the VOLK converters module
 for the default version of libsoapysdr.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"

override_dh_installdocs:
	dh_installdocs --link-doc=soapysdr0.8-module-volkconverters

=== debian/watch ===
version=4
https://github.com/pothosware/SoapyVOLKConverters/tags .*/soapy-volkconverters-([\d\.]+)\.tar\.(?:xz|gz|bz2)
